/* ================================================================  */
// 23 Septembre 2004 sur une base  5/10/95   10/10/96       09/10/97     
#include <stdio.h>
#include <stdlib.h>
#include "math.h" 
#include "tete_RDV.h" 

 


/*****************************************************************************/
/*  La fonction Fx calcule d2X_i/dt2. Elle prend comme arguments:            */
/*        X : abscisses du chasseur                                          */
/*        Y : ordonnees du chasseur                                          */
/*****************************************************************************/
double Fx(double X,double Y,double Z,double Xp,double Yp,double Zp,double px)
	{extern  parametres para_phy;
	double F=0;  
        F = + (para_phy.trois*(para_phy.Omega*para_phy.Omega) *X) 
                    +  2 * para_phy.Omega * Yp + px; 
	return F;
	}

/*****************************************************************************/
/*  La fonction Fy calcule d2Y_i/dt2. Elle prend comme arguments:            */
/*        X : abscisses du chasseur                                          */
/*        Y : ordonnees du chasseur                                          */
/*****************************************************************************/
double Fy(double X,double Y,double Z,double Xp,double Yp,double Zp,double py)
	{extern  parametres para_phy;
	double F=0;  
        F = -  (0)   -   2 * para_phy.Omega * Xp + py; 
        return F;
	}

/*****************************************************************************/
/*  La fonction Fz calcule d2Z_i/dt2. Elle prend comme arguments:            */
/*        X : abscisses du pendule                                           */
/*        Y : ordonnees du pendule                                           */
/*****************************************************************************/
double Fz(double X,double Y,double Z,double Xp,double Yp,double Zp,double pz)
	{extern  parametres para_phy;
	double F=0;  
        F = - para_phy.Omega*para_phy.Omega*Z + pz; 
        return F;
	}
                
void  nextD()
   {    static double X1,Y1,Z1,X1p,Y1p,Z1p; 
        extern double X,Y,Z,Xp,Yp,Zp;
        extern double px,py,pz;
        extern double t, *x,*y,*z,tcalc; 
        static double dt;
        extern int it_t;
        extern  parametres para_phy;
        int  j,Npd=10;
        dt=para_phy.dt;
                     /****************************************/
                     /* Resolution du systeme dynamique par  */
                     /* la methode de Runge-Kutta d'ordre 2  */
                     /****************************************/

for (j=1;j<=tcalc/dt;j++)
	{t = t+dt; 
	 /* calcul du point milieu X1,Y1 */ 
		X1p=Xp+Fx(X,Y,Z,Xp,Yp,Zp,px)*dt*0.5; 
		Y1p=Yp+Fy(X,Y,Z,Xp,Yp,Zp,py)*dt*0.5;
                Z1p=Zp+Fz(X,Y,Z,Xp,Yp,Zp,pz)*dt*0.5;

		X1 = X + 0.5 * dt * X1p;
                Y1 = Y + 0.5 * dt * Y1p;
                Z1 = Z + 0.5 * dt * Z1p;
		 
           /* calcul du point final */
		Xp=Xp+Fx(X1,Y1,Z1,X1p,Y1p,Z1p,px)*dt;
		Yp=Yp+Fy(X1,Y1,Z1,X1p,Y1p,Z1p,py)*dt;
		Zp=Zp+Fz(X1,Y1,Z1,X1p,Y1p,Z1p,pz)*dt;
                
                X = X + dt * Xp;
                Y = Y + dt * Yp;
                Z = Z + dt * Zp;
                
 }
 if(para_phy.spe==0){px=0;py=0;pz=0;} //raz de la pousse
 
 it_t=it_t+1; 
 if(it_t<para_phy.nx){
for (j=it_t;j<=para_phy.nx;j++)
 {x[  j]=X;
  y[  j]=Y;
  z[  j]=Z;
 }}else{ 
 x[para_phy.nx]=X;
 y[para_phy.nx]=Y;
 z[para_phy.nx]=Z;

 for (j=1;j<=para_phy.nx-1;j++)
 {x[  j]=x[  j+1];
  y[  j]=y[  j+1];
  z[  j]=z[  j+1];}
 }

}
///// 
 
 

 
